unit Animator;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, Complex;

type
  TFrAnimator = class(TForm)
    btCancel: TBitBtn;
    BtOK: TBitBtn;
    PnDestinationPoint: TPanel;
    PnStartingPoint: TPanel;
    Label3: TLabel;
    Label9: TLabel;
    SpeedButton1: TSpeedButton;
    edName: TEdit;
    edDir: TEdit;
    Label1: TLabel;
    edNum: TEdit;
    Label7: TLabel;
    edRPoC1: TEdit;
    Label8: TLabel;
    edIPoC1: TEdit;
    Label2: TLabel;
    edMagnit1: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    edRPoC2: TEdit;
    Label13: TLabel;
    edIPoC2: TEdit;
    Label14: TLabel;
    edMagnit2: TEdit;
    Label15: TLabel;
    edStarting: TEdit;
    CbAvi: TCheckBox;
    Label16: TLabel;
    edFPS: TEdit;
    procedure BtOKClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

implementation

{$R *.DFM}

uses
  FileCtrl;

procedure TFrAnimator.BtOKClick(Sender: TObject);

  function CheckNum(Edit: TEdit; min, max: Double): Boolean;
    var
      nx: double;
    begin
    nx := StrToFloatDef( Edit.Text, min - 1 );
    if ( nx < min ) or ( nx > max ) then
      begin
      Edit.setfocus;
      beep;
      Result := False;
      end
    else
      Result := True;
    end;

  begin
  if not CheckNum( edStarting, 1, 9999 ) then
    exit;
  if not CheckNum( edNum, 1, 10000 - StrToInt( edStarting.Text ) ) then
    exit;
  if not CheckNum( edFPS, 1, 25 ) then
    exit;
  if not CheckNum( edRPoC1, -9999, 9999 ) then
    exit;
  if not CheckNum( edIPoC1, -9999, 9999 ) then
    exit;
  if not CheckNum( edMagnit1, 0.00001, 1E+18 ) then
    exit;

  if not CheckNum( edRPoC2, -9999, 9999 ) then
    exit;
  if not CheckNum( edIPoC2, -9999, 9999 ) then
    exit;
  if not CheckNum( edMagnit2, 0.00001, 1E+18 ) then
    exit;

  if Trim(edName.Text) = '' then
    begin
    edName.SetFocus;
    beep;
    exit;
    end;

  if Trim(edDir.Text) = '' then
    begin
    edName.SetFocus;
    beep;
    exit;
    end;

  if not DirectoryExists( edDir.Text ) then
    ForceDirectories( edDir.Text );

  ModalResult := mrOk;
  end;

procedure TFrAnimator.FormShow(Sender: TObject);
  begin
  edDir.Text := GetCurrentDir;
  edName.Text := '';
  edNum.Text := '5';
  edFPS.Text := '10';
  edStarting.Text := '1';
  end;

end.
