unit Julia;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Mandelbrot, Colors;

type
  TFrJulia = class(TForm)
    Image1: TImage;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    Mand : TMandelbrot;
    Fmandelset : TMandelSet;
  public
    procedure TracciaJulia(real, imag: Extended; AColors: TColorize);
  end;

var  
  FrJulia: TFrJulia;

implementation

{$R *.DFM}
procedure TFrJulia.TracciaJulia(real, imag: Extended; AColors: TColorize);
  begin
  Image1.Picture.Bitmap.Width := Image1.Width;
  Image1.Picture.Bitmap.Height := Image1.Height;
  Image1.Picture.Bitmap.PixelFormat := pf24bit;
  with mand.Par do
    begin
    FRealPert := real;
    FImagPert := imag;
    FWidth := Image1.Picture.Bitmap.Width;
    FHeight := Image1.Picture.Bitmap.Height;
    end;
  mand.Prepare( Fmandelset, AColors );
  mand.Render( false );
  image1.Repaint;//	Invalidate repaints background too
  end;

procedure TFrJulia.FormCreate(Sender: TObject);
  begin
  Mand := TMandelbrot.Create( Image1.Picture.Bitmap );
  with mand.Par do
    begin
    FCentReal := 0;
    FCentImag := 0;
    FMagnitud := 0.5;
    FIter := 50;
    FWidth := Image1.Picture.Bitmap.Width;
    FHeight := Image1.Picture.Bitmap.Height;
    FAspectR := 1;
    FJulia := true;
    FBailout := 4;
    FRealPert := 0;
    FImagPert := 0;
    FApplyC := Iter;
    FFormula := quad;
    FAlgo := maInterp8;
    FCQuad := false;
    end;
  Fmandelset.FVersion := ''; // initialize to zeros
  end;

procedure TFrJulia.FormDestroy(Sender: TObject);
  begin
  Mand.free;
  end;

end.
