unit Orbits;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
	TFrOrbits = class(TForm)
		Image1: TImage;
    Panel1: TPanel;
    cbLines: TCheckBox;
    procedure FormResize(Sender: TObject);
    procedure cbLinesClick(Sender: TObject);
	private
		{ Private declarations }
	public
		{ Public declarations }
		procedure TracciaOrbite(real, immag: extended; tracing: boolean);
	end;

var
	FrOrbits: TFrOrbits;

implementation

{$R *.DFM}

procedure TFrOrbits.TracciaOrbite(real, immag: Extended; tracing: boolean);
	var
		col: byte;
		x,y,it,mit, lit: integer;
		r,i,zqr,zqi,pz: extended;
		CurrLine: PByteArray;
		Points: array[0..250] of TPoint;
	begin
	for y:=0 to Image1.Height-1 do
		begin
		CurrLine := Image1.Picture.Bitmap.ScanLine[y];
		i := (y / Image1.Height) * 5 - 2.5;
		for x:=0 to Image1.Width-1 do
			begin
			r := (x / Image1.Width) * 5 - 2.5;
			if (i*i)+(r*r) > 4 then
				col := 4
			else
				col := 6;
			CurrLine[x] := col;
			end;
		end;
	if (real <> 0) and (immag <> 0) then
		begin
		mit := 250;
		pz := 0;
		zqi := 0;
		zqr := 0;
		it := 0;
		while ((it < mit) and (ZqR + ZqI < 4)) do
			begin
			r := ZqR - ZqI + real;
			i := PZ + PZ + immag;
			ZqI := i * i;
			PZ := r * i;
			ZqR := r * r;
			Points[it].x := round(((r + 2.5) / 5) * image1.Width);
			Points[it].y := round(((i + 2.5) / 5) * image1.Height);
			inc(it);
			end;
		Points[it].x := round(((ZqR - ZqI + real + 2.5) / 5) * image1.Width);
		Points[it].y := round(((PZ + PZ + immag + 2.5) / 5) * image1.Height);

    lit := it;
    if tracing then
  		image1.Canvas.Polyline(Slice(Points, it))
    else
      for it := 0 to lit do
        image1.Canvas.Pixels[ points[ it ].x, points[ it ].y ] := clBlack;
        
		end;
	Image1.Invalidate;
	end;

procedure TFrOrbits.FormResize(Sender: TObject);
	begin
	ClientHeight := Clientwidth;
	Image1.Picture.Bitmap.PixelFormat := pf8bit;
	Image1.Picture.Bitmap.Width := Image1.Width;
	Image1.Picture.Bitmap.Height := Image1.Height;
	TracciaOrbite( 0, 0, cblines.checked );
	end;

procedure TFrOrbits.cbLinesClick(Sender: TObject);
  begin
	TracciaOrbite( 0, 0, cblines.checked );
  end;

end.
