unit complex;

interface

uses Math, SysUtils;

type
	TComplex = record
		X,Y: Extended
	end;

function Teta(const zeta: TComplex): Extended;
function Modulo(const zeta: TComplex): Extended;
function Modulo2(const zeta: TComplex): Extended;
function ZetaAllaZeta(const zeta: TComplex): TComplex;
function StrToFloatDef( AValue: String; DefValue: Extended ): Extended;

implementation

function StrToFloatDef( AValue: String; DefValue: Extended ): Extended;
  begin
    try
    Result := StrToFloat( AValue );
    except
    Result := DefValue;
    end;
  end;

function Modulo(const zeta: TComplex): Extended;
begin
	result := sqrt(zeta.X*zeta.X + zeta.Y*zeta.Y)
end;

function Modulo2(const zeta: TComplex): Extended;
	begin
	result := zeta.X*zeta.X + zeta.Y*zeta.Y;
	end;

function Teta(const zeta: TComplex): Extended;
begin
	if zeta.X <> 0 then
		result := ArcTan2(zeta.y, zeta.x)
	else if zeta.y = 0.0 then
		result := 0.0
	else if zeta.y > 0 then
		result := PI/2
	else result := -PI/2;
end;

function ZetaAllaZeta(const zeta: TComplex): TComplex;
	var
		lnm,m,t,s,c: Extended;
	begin
	m := Modulo2(zeta);
	if m>0 then
		begin
		t := Teta(zeta);
		lnm := ln(m) / 2;
		SinCos(zeta.x*t + zeta.y*Lnm, s, c);
		m := EXP(zeta.x*lnm - zeta.y*t);
		result.x := m*c;
		result.y := m*s;
		end
	else
		begin
		result.x:=0;
		result.y:=0;
		end;
	end;
end.
 